package com.tagfriendly.solr;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Created by IntelliJ IDEA.
 * User: gary
 * Date: Nov 23, 2007
 * Time: 7:42:58 PM
 * To change this template use File | Settings | File Templates.
 */
class ArtistIdVendor {
    private final Iterator<Integer> ids;
    private final Lock lock = new ReentrantLock(true);

    ArtistIdVendor(Connection con) throws SQLException {
        final PreparedStatement getArtistIds = con.prepareStatement("select artistId from Rela.Artist order by artistId");
        final List<Integer> artistIds = new ArrayList<Integer>();
        try {
            getArtistIds.clearParameters();
            ResultSet rs = getArtistIds.executeQuery();
            while (rs.next())
                artistIds.add(rs.getInt(1));
            rs.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
        }
        getArtistIds.close();
        ids = artistIds.iterator();
    }

    int nextId() {
        lock.lock();
        int i = 0;
        try {
            if (!ids.hasNext())
                i = -1;
            else
                i = ids.next();
        } finally {
            lock.unlock();
        }
        return i;
    }

}
