package com.tagfriendly.solr;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.*;

import java.io.IOException;
import java.io.ByteArrayOutputStream;
import java.net.URLEncoder;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Created by: gary at Nov 2, 2007 2:34:34 PM
 * http://host:port/solr/update
 * Content-Type:text/xml; charset=utf-8
 * 
 */
class SolrClient {
    private final String urlBase;
    private final HttpClient client;
    private Lock lock;

    static SolrClient newInstance() {
        return new SolrClient("127.0.0.1",8983,"solr");
    }
    
    private SolrClient(String host, int port, String application) {
        client = new HttpClient();
        urlBase = "http://"  + host + ":" + port + "/" + application;
        lock = new ReentrantLock(true);
    }

    void optimize() throws IOException {
        if (true) return; // no optimizing for now.
        lock.lock();
        try {
            System.out.println("OPTIMIZING...");
            String optimize = "<optimize/>";
            PostMethod post = new PostMethod(urlBase + "/update");
            post.setRequestHeader("Content-Type","text/xml; charset=utf-8");
            RequestEntity entity = new ByteArrayRequestEntity(optimize.getBytes(Item.ENCODING),Item.ENCODING);
            post.setRequestEntity(entity);
            int result = client.executeMethod(post);
            if (result != HttpStatus.SC_OK)
                throw new IOException("Not ok. " + result);
        } finally {
            lock.unlock();
        }

    }

    void index(Item it) throws IOException {
//        lock.lock();
//        try {
            StringBuilder sb = new StringBuilder();
            sb.append("<add>");
            sb.append(it.toXml());
            sb.append("</add>");
            String s = sb.toString();

            //System.out.println(s);

            PostMethod post = new PostMethod(urlBase + "/update");
            post.setRequestHeader("Content-Type","text/xml; charset=utf-8");
            RequestEntity entity = new ByteArrayRequestEntity(s.getBytes(Item.ENCODING),Item.ENCODING);
            post.setRequestEntity(entity);
            int result = client.executeMethod(post);
            if (result != HttpStatus.SC_OK)
                throw new IOException("Not ok. " + result);
//        } finally {
//            lock.unlock();
//        }
    }
}
